package mx.gob.jumapacelaya.Services;

import mx.gob.jumapacelaya.models.Usuario;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Service;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;

@Service
public class UserService {

    private final JdbcTemplate jdbcTemplate;

    public UserService(JdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    public List<Usuario> getUsusarios() {
        List<Usuario> usuarios = new ArrayList<>();
        String query = "select usuarioid, empleadoid, nombrecompleto " +
                        "from soldigitusuarios " +
                        "order by nombrecompleto";

        return jdbcTemplate.query(query, usuarioRowMapper());
    }

    private RowMapper<Usuario> usuarioRowMapper() {
        return (rs, rowNum) -> new Usuario(
                rs.getString("nombrecompleto"),
                rs.getString("usuarioid"),
                rs.getInt("empleadoid")
        );
    }
}
